    
       var labelWidth = 160;
       var fieldWidth = 100;
       var rowHeight = 25;
       var margin = 13;
      
      function bumpRectDownwards(bounds,y)
          {
          var h = bounds[3] - bounds[1];
          var bump = y;
      
          bounds[1] += bump;
          bounds[3] += bump;
          }
      
      function addField(dlg,rect,label,name,defaultValue)
          {
          rect[2] = rect[0] + labelWidth;
      
          var controlName = name + "Ctl";
      
          var fieldRect = [rect[0] + labelWidth,rect[1],rect[2] + margin + fieldWidth,rect[3]];
          dlg.add('statictext',rect,label + ":");
          dlg.add('edittext',fieldRect,defaultValue,{name:controlName});
      
          dlg.fieldNames[dlg.fieldNames.length] = name;
      
          bumpRectDownwards(rect,rowHeight);
          }
      
      function setNiceWindowBounds(dlg)
          {
          var i;
          var r = [0,0,0,0];
      
          for(i = 0; i < dlg.children.length; i++)
              {
              var child = dlg.children[i];
              var childR = child.bounds;
              if(childR[2] > r[2])
                  r[2] = childR[2];
              if(childR[3] > r[3])
                  r[3] = childR[3];
              }
      
          r[2] += margin;
          r[3] += margin;
      
          r[0] += dlg.bounds[0];
          r[1] += dlg.bounds[1];
          r[2] += dlg.bounds[0];
          r[3] += dlg.bounds[1];
      
          dlg.bounds = r;
          }
      
      function dvbDoDialog(d)
          {
          var dlg = new Window('dialog',d[0],[110,60,2000,2000]);
      
          var r = [margin,margin,200,margin + 20]; // work our way downwards
      
          // optional bit of text at the top
          if(d[1] != "")
              {
              dlg.add('statictext',r,d[1]);
              bumpRectDownwards(r,rowHeight);
              }
      
          dlg.fieldNames = new Array();
      
          // fields
          var i;
          for(i = 2; i < d.length; i++)
              {
              var item = d[i];
              addField(dlg,r,item[0],item[1],item[2]); // label and editfield
              }
      
          // ok/cancel
          bumpRectDownwards(r,5);
          var buttonTop = r[1];
          var buttonBottom = buttonTop + 15;
          dlg.add('button',[10,buttonTop,90,buttonBottom],"OK",{name:'ok'});
          dlg.add('button',[100,buttonTop,180,buttonBottom],"Cancel",{name:'cancel'});
      
          setNiceWindowBounds(dlg);
      
          var resultCode = dlg.show();
          // will be 1 for ok, 2 for cancel.
      
          alert("dialog result = " + resultCode);
      
          // transfer the values out of the controls, into the... result;
          var result = null;
         if(resultCode == 1)
         {
             result = new Object();
             var i;
             for(i = 0; i < dlg.fieldNames.length; i++)
             {
                 var fieldName = dlg.fieldNames[i];
                 var controlName = fieldName + "Ctl";
                 var value = dlg[controlName].text;
                 result[fieldName] = value;
             }
         }
         
         return result;
         }
     
     
    ;
       
       
       function testIt()
           {
           var d = 
              [
              "A Test Dialog",        // first item: window name
              "This is a test of dvbDialogLib.jsx",   // next item: some text at the top
              ["First field","f1",200],
              ["Second field","f2",313],
              ["Last field","zoot","the fish"]
              ];
      
          var result = dvbDoDialog(d);
          }
      
      testIt();
      
